#!/usr/bin/perl -w

use ngramModule;

use strict;

&main();

sub main()
{
	if( scalar( @ARGV ) != 2 )
	{
		print( "Usage: app.pl <server_name> <port_number>\n" );
		return;
	}
	my $HOST_NAME = $ARGV[0];
	my $PORT = $ARGV[1];
	my $socket = &connect( $HOST_NAME, $PORT );

	print( "\n>> " );
	while( my $command = <STDIN> )
	{
		chomp( $command );
		my @tokens = split( /\s+/, $command );
		my $method = $tokens[0];
		my $nPlusOne = scalar( @tokens );
		my $n = $nPlusOne - 1;
		my $string = join( " ", @tokens[1..$n] );

		if( $method eq "NG" )
		{
			my @results;
			&getNgram( $socket, $string, \@results );
			if( scalar( @results ) == 0 )
			{
				print( "$string 0\n" );
			}
			else
			{
				foreach my $result ( @results )
				{
					print( "$result\n" );
				}
			}
		}
		elsif( $method eq "CNT" )
		{
			print( "CNT: ", &getNgramCount( $socket, $string ), "\n" );
		}
		elsif( $method eq "PRB" )
		{
			print( "PRB: ", &getProb( $socket, $string ), "\n" );
		}
		elsif( $method eq "ABS" )
		{
			print( "ABS: ", &getAbsDiscountProb( $socket, $string ), "\n" );
		}
		elsif( $method eq "KN" )
		{
			print( "KN: ", &getKNDiscountProb( $socket, $string ), "\n" );
		}
		elsif( $method eq "KNMC" )
		{
			print( "KNMC: ", &getKNMCDiscountProb( $socket, $string ), "\n" );
		}
		elsif( $method eq "DIR" )
		{
			print( "DIR: ", &getDirichletProb( $socket, $string ), "\n" );
		}
		elsif( $method eq "DKN" )
		{
			print( "DKN: ", &getDKNProb( $socket, $string ), "\n" );
		}

		print( "\n>> " );
	}

	#while( my $ngram = <> )
	#{
	#	chomp( $ngram );
	#	my @results;
	#	&getNgram( $socket, $ngram, \@results );
	#	if( scalar( @results ) == 0 )
	#	{
	#		print( "$ngram 0\n" );
	#	}
	#	else
	#	{
	#		foreach my $result ( @results )
	#		{
	#			print( "$result\n" );
	#		}
	#	}
	#	print( "\n>> " );
	#}

	#my $string = "the quick brown fox jumped";

	#print( "CNT: ", &getNgramCount( $socket, $string ), "\n" );
	#print( "PRB: ", &getProb( $socket, $string ), "\n" );
	#print( "ABS: ", &getAbsDiscountProb( $socket, $string ), "\n" );
	#print( "KN: ", &getKNDiscountProb( $socket, $string ), "\n" );
	#print( "KNMC: ", &getKNMCDiscountProb( $socket, $string ), "\n" );
	#print( "DIR: ", &getDirichletProb( $socket, $string ), "\n" );
	#print( "DKN: ", &getDKNProb( $socket, $string ), "\n" );

	&closeConnection( $socket );
}

#&main();
