#!/usr/bin/perl -w

use strict;


sub createIdxFile()
{
	my $dir = shift;

	my %idx;
	my $ngramSize;
	my @files = eval( "<$dir/*>" );
	foreach my $file ( @files )
	{
		if( $file !~ /.+\/\d+gm-\d+$/ )
		{
			next;
		}
		$file =~ /.+\/\d+gm-(\d+)$/;
		my $fileNo = $1;

		open( INFILE, "<$file" ) or die( "Cannot open $file for reading!\n" );
		my $line = <INFILE>;
		chomp( $line );
		my( $ngram, $count ) = split( /\t/, $line );
		if( !defined( $ngramSize ) )
		{
			my @tokens = split( /\s+/, $ngram );
			$ngramSize = scalar( @tokens );
		}
		$idx{$fileNo} = $ngram;
		close( INFILE );
	}

	if( !defined( $ngramSize ) )
	{
		print( "N-gram size not defined for $dir\n" );
		return;
	}
	my $idxFilePath = "$dir/$ngramSize" . "gm.idx";
	open( OUTFILE, ">$idxFilePath" ) or die( "Cannot open $idxFilePath for writing!\n" );
	foreach my $fileNo ( sort {$a <=> $b} keys( %idx ) )
	{
		my $ngram = $idx{$fileNo};
		my $fileName = "$ngramSize" . "gm-$fileNo.gz";
		print( OUTFILE "$fileName\t$ngram\n" );
	}
	close( OUTFILE );
}

1;
