#include "key.h"

Key :: Key( int n, const UnigramKey* vals ) : numOfValues( n )
{
	values = new UnigramKey[numOfValues];
	for( int i = 0; i < n; i++ )
		values[i] = vals[i];
}

Key :: Key( int n ) : numOfValues( n )
{
	values = new UnigramKey[numOfValues];
	for( int i = 0; i < n; i++ )
		values[i] = 0;
}

Key :: Key( const Key& key )
{
	numOfValues = key.numOfValues;
	values = new UnigramKey[numOfValues];

	for( int i = 0; i < numOfValues; i++ )
		values[i] = key.values[i];
}

Key& Key :: operator=( const Key& key )
{
	if( numOfValues != key.numOfValues )
	{
		if( numOfValues != 0 )
			delete[] values;

		numOfValues = key.numOfValues;
		values = new UnigramKey[numOfValues];
	}

	for( int i = 0; i < numOfValues; i++ )
		values[i] = key.values[i];

	return *this;
}

bool Key :: operator<( const Key& key ) const
{
	//exception may be thrown here if sizes do not match
	for( int i = 0; i < numOfValues; i++ )
	{
		if( values[i] < key.values[i] )
			return true;
		else if( values[i] > key.values[i] )
			return false;
	}

	//means they are equal
	return false;
}

bool Key :: operator==( const Key& key ) const
{
	//exception may be thrown here if sizes do not match
	for( int i = 0; i < numOfValues; i++ )
	{
		if( values[i] != key.values[i] )
			return false;
	}

	return true;
}

bool Key :: operator!=( const Key& key ) const
{
	return !( *this == key );
}

bool Key :: operator<=( const Key& key ) const
{
	return ((*this < key) || (*this == key ));
}

ostream& operator<<( ostream& os, const Key& key )
{
	for( int i = 0; i < key.numOfValues; i++ )
	{
		os << key.values[i];
		if( key.numOfValues != (i + 1) )
			os << ' ';
	}

	return os;
}

istream& operator>>( istream& is, Key& key )
{
	for( int i = 0; i < key.numOfValues; i++ )
	{
		is >> key.values[i];
		if( is.fail() )
			throw( "Couldn't read key from stream!" );
	}

	return is;
}

