#ifndef _KEY_H_
#define _KEY_H_

#include <iostream>

using namespace std;

typedef unsigned long UnigramKey;

class Key
{
	private:
		int numOfValues;
		UnigramKey* values;
	public:
		Key() : numOfValues( 0 ), values( NULL )
		{
		}
		Key( int );
		Key( int, const UnigramKey* );
		Key( const Key& );
		~Key()
		{
			if( values )
				delete[] values;
		}

		Key& operator=( const Key& );
		bool operator<( const Key& ) const;
		bool operator==( const Key& ) const;
		bool operator!=( const Key& ) const;
		bool operator<=( const Key& ) const;

		friend ostream& operator<<( ostream&, const Key& );
		friend istream& operator>>( istream&, Key& );
};

#endif
