#ifndef _KEYMAP_H_
#define _KEYMAP_H_

#include <iostream>
#include <fstream>
#include <string>
#include <map>

#include "key.h"
#include "record.h"

using namespace std;

#define SPECIAL_SYMBOL	"_"

class KeyMap
{
	private:
		struct Pair
		{
			UnigramKey key;
			CountInteger count;

			Pair() : key( 0 ), count( 0 )
			{
			}
			Pair( UnigramKey k, CountInteger c ) : key( k ), count( c )
			{
			}
		};
		map<string, Pair> keyMap;

	public:
		KeyMap( const string& );
		void getKey( const vector<string>&, int, Key& ) const;
		void getKey( const Record&, int, Key& ) const;
		CountInteger getCount( const string& ) const;
};

#endif
