#!/usr/bin/perl -w

use strict;

use constant PN => "port_number";
use constant MC => "max_connections";
use constant BL => "backlog";

use constant OND => "original_ngrams_dir";
use constant MNI => "min_ngram_to_index";
use constant MXI => "max_ngram_to_index";
use constant WCD => "wildcards";
use constant RND => "resorted_ngrams_dir";
use constant IND => "index_dir";


sub parseConfigFile()
{
	my( $configFile, $serverInfoP, $langInfoP ) = @_;

	my $config;
	{
		local $/ = undef;
		open( INFILE, "<$configFile" ) or die( "Cannot open $configFile for reading!\n" );
		$config = <INFILE>;
		close( INFILE );
	}

	if( !defined( $config ) )
	{
		die( "File $configFile could not be read!\n" );
	}

	if( $config =~ /<server>(.+)<\/server>/s )
	{
		my $m = $1;
		$m =~ s/^\s+//gs;
		$m =~ s/\s+$//gs;

		my @constants = ( PN, MC, BL );
		foreach my $constant ( @constants )
		{
			if( $m =~ /<$constant>(.+)<\/$constant>/s )
			{
				my $val = $1;
				$val =~ s/^\s+//gs;
				$val =~ s/\s+$//gs;
				$serverInfoP -> {$constant} = $val;
			}
		}
	}

	if( $config =~ /<languages>(.+)<\/languages>/s )
	{
		my $m = $1;
		$m =~ s/^\s+//gs;
		$m =~ s/\s+$//gs;
		my @languages = split( /\s+/, $m );
		foreach my $language ( @languages )
		{
			if( $config =~ /<$language>(.+)<\/$language>/s )
			{
				$m = $1;

				my @constants = ( OND, MNI, MXI, WCD, RND, IND );
				foreach my $constant ( @constants )
				{
					if( $m =~ /<$constant>(.+)<\/$constant>/s )
					{
						my $val = $1;
						$val =~ s/^\s+//gs;
						$val =~ s/\s+$//gs;
						$langInfoP -> {$language} -> {$constant} = $val;
					}
				}
			}
		}
	}
}

1;
