#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <vector>
#include <algorithm>

#include <cstdlib>

using namespace std;

#include "record.h"

int comparePos;

int compare( const Record* rec1, const Record* rec2 )
{
	for( int i = comparePos; i < rec1 -> numOfWords; i++ )
	{
		int comparison = ( rec1 -> words[i] ).compare( rec2 -> words[i] );
		if( comparison < 0 )
			return true;
		if( comparison > 0 )
			return false;
	}
	for( int i = 0; i < comparePos; i++ )
	{
		int comparison = ( rec1 -> words[i] ).compare( rec2 -> words[i] );
		if( comparison < 0 )
			return true;
		if( comparison > 0 )
			return false;
	}
	return false;
}

int main( int argc, char* argv[] )
{
	const int ngramSize = atoi( argv[1] );
	comparePos = atoi( argv[2] );

	ostringstream oss;
	oss << ngramSize;

	const string ngramFilesPath = string( argv[3] );
	const string sortedFilesPath = string( argv[4] );

	const string idxFileName = ngramFilesPath + "/" + oss.str() + "gm.idx";
	ifstream fo( idxFileName.c_str() );
	while( !fo.eof() )
	{
		string fileName, firstNgram;
		fo >> fileName;
		for( int i = 0; i < ngramSize; i++ )
			fo >> firstNgram;
		if( fo.fail() )
			break;

		fileName.resize( fileName.length() - 3 );
		cout << "Sorting " << fileName << endl;
		const string filePath = ngramFilesPath + "/" + fileName;
		ifstream fo2( filePath.c_str() );
		vector<Record*> recordsToSort;
		while( !fo2.eof() )
		{
			vector<string> words;
			string word;
			for( int j = 0; j < ngramSize; j++ )
			{
				fo2 >> word;
				if( fo2.fail() )
					break;
				words.push_back( word );
			}
			if( fo2.fail() )
				break;

			CountInteger count;
			fo2 >> count;

			recordsToSort.push_back( new Record( count, words ) );
		}

		sort( recordsToSort.begin(), recordsToSort.end(), compare );

		const string outFile = sortedFilesPath + "/" + fileName + ".sorted";
		ofstream fo3( outFile.c_str() );
		for( int i = 0; i < recordsToSort.size(); i++ )
		{
			fo3 << *recordsToSort[i] << endl;
			delete recordsToSort[i];
		}
		fo3.close();
	}
	fo.close();

	return 0;
}
