#!/usr/bin/perl -w

use parseConfigFile;

use strict;

&main();

sub main()
{
	if( scalar( @ARGV ) != 1 )
	{
		die( "Usage: startServer.pl <configuration file>\n" );
	}
	my $configFile = $ARGV[0];

        my %serverInfo;
        my %langInfo;

        &parseConfigFile( $configFile, \%serverInfo, \%langInfo );

	my $args = $serverInfo{&PN};
	$args .= " " . $serverInfo{&MC};
	$args .= " " . $serverInfo{&BL};

	my @languages = keys( %langInfo );
	my $numOfLanguages = scalar( @languages );
	$args .= " $numOfLanguages";
        foreach my $language ( @languages )
        {
		$args .= " $language";
		$args .= " " . $langInfo{$language}{&MNI};
		$args .= " " . $langInfo{$language}{&MXI};
		$args .= " " . $langInfo{$language}{&OND};
		$args .= " " . $langInfo{$language}{&IND};

		if( $langInfo{$language}{&WCD} eq "YES" )
		{
			$args .= " 1";
			$args .= " " . $langInfo{$language}{&RND};
		}
		else
		{
			$args .= " 0";
		}
	}

	system( "./server $args" );
}
